#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_admin.py                                                       
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_admin.py vereint den Dialog und die Tätigkeiten eines Administrators
 Dieses Modul wird nicht geladen, wenn der user kein Administrator ist.
________________________________________________________________________
'''

from a_konstanten import *
from a_admin_hilfen import *

import a_tool
import a_db
import a_session as a_s


    
def erledige_admin_dialog():
        
    a_tool.prt('<div class="sh admin"><h2>Admintools</h2>\n')
    a_tool.prt('''<form class="boxcontrol" action="a_main.py" method="POST" style="font-weight:bold;text-align:right;">
        <input name="showhide_sid" type="hidden" value="{sid}"  />
        Alle Boxen <input name="showhide_20" type="submit" value="+" style="font-weight:bold;color:green;" />
        <input name="showhide_20" type="submit" value="‒" style="font-weight:bold;color:red;" />
    </form>'''.format( sid=a_s.aS.sid))

    #Dateien einlesen
    if start_admin_box(1,'Dateien einlesen',neuezeile=True, extraklasse="w35",hilfetext=upload_hilfe):
        
        #Kurslisten einlesen    
        a_tool.prt(a_tool.headhelper("⇧",'red','Kurslisten (aus WinQD) einlesen'))
        a_tool.prt(a_tool.popuphilfe(uploadq_hilfe))
        a_tool.prt('<br>')
        
        a_tool.prt('''  <form action="a_listen_einlesen.py" method="POST"  enctype="multipart/form-data">
            <input name="kursliste" type="file" size="5"  />
            <input type="submit" name="hochladen" value=" Hochladen " />
            <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden">
        </form><br>\n   ''')
        #Schülerliste einlesen
        if a_db.get_config_int('minimum-js')<11:
            a_tool.prt(a_tool.headhelper("⇧",'orange','Schülerliste (WinSV, U+M) einlesen'))
            a_tool.prt(a_tool.popuphilfe(uploadum_hilfe,breit=True))
            a_tool.prt('''\n\t\t<form action="a_um_einlesen.py" method="POST"  enctype="multipart/form-data">ASV
                <input name="schuelerlisteasv" type="file" size="15"  />
                <input type="submit" name="hochladen" value=" Hochladen " />
                <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden">
                <input name="uploadtype" value="schuelerliste" type="hidden">
            </form><br>\n   ''')
            a_tool.prt('''\n\t\t<form action="a_um_einlesen.py" method="POST"  enctype="multipart/form-data">alt.
                <input name="schuelerliste" type="file" size="15"  />
                <input type="submit" name="hochladen" value=" Hochladen " />
                <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden">
                <input name="uploadtype" value="schuelerliste" type="hidden">
            </form><br>\n   ''')
            
        #Lehrerliste einlesen
        a_tool.prt(a_tool.headhelper("⇧",'orange','Lehrerliste (für U+M-Stufe) einlesen'))
        a_tool.prt(a_tool.popuphilfe(uploadl_hilfe,breit=True))
        a_tool.prt('''\n\t\t<form action="a_um_einlesen.py" method="POST"  enctype="multipart/form-data">ASV
                <input name="lehrerlisteasv" type="file" size="5"  />
                <input type="submit" name="hochladen" value=" Hochladen " />
                <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden">
                <input name="uploadtype" value="lehrerliste" type="hidden">
            </form><br>\n   ''')
        a_tool.prt('''\n\t\t<form action="a_um_einlesen.py" method="POST"  enctype="multipart/form-data">alt
                <input name="lehrerliste" type="file" size="5"  />
                <input type="submit" name="hochladen" value=" Hochladen " />
                <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden">
                <input name="uploadtype" value="lehrerliste" type="hidden">
            </form><br>\n   ''')
        
        #HTML-Dateien einlesen
        a_tool.prt(a_tool.headhelper("⇧",'magenta','Serienbriefvorlagen einlesen'))
        a_tool.prt(a_tool.popuphilfe(serienbriefe_hilfe))
        a_tool.prt('<br>Absenzenstatus-Vorlage:'+a_tool.popuphilfe(asvorlage_hilfe)+'''<form action="a_upload.py" method="POST"  enctype="multipart/form-data">
                <input name="absenzenbrief" type="file" size="5" />
                    <input type="submit" name="hochladen" value=" Hochladen " />
                    <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden" />
                </form> ''')
        a_tool.prt('Mailcode-Brief-Vorlage:'+a_tool.popuphilfe(mcvorlage_hilfe)+'''<form action="a_upload.py" method="POST"  enctype="multipart/form-data">
                <input name="mailcodebrief" type="file" size="5"  />
                    <input type="submit" name="hochladen" value=" Hochladen " />
                    <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden" />
                </form> ''')
        a_tool.prt('Passwort-Brief-Vorlage:'+a_tool.popuphilfe(pwvorlage_hilfe)+'''<form action="a_upload.py" method="POST"  enctype="multipart/form-data">
                <input name="passwortbrief" type="file" size="5"  />
                    <input type="submit" name="hochladen" value=" Hochladen " />
                    <input name="uploadsid" value="'''+str(a_s.aS.sid)+'''" type="hidden" />
                </form> ''')
        a_tool.prt('</div>\n\n')
    
    #MailCode ändern
    if start_admin_box(2,'Schüler-Mailcode', extraklasse="w15",zeichen="⚷",zeichenfarbe='blue',hilfetext=mailcode_hilfe):
    
        # Suche nach Schülern
        select='<select name="mcperson">'
        select+='\t<option>-</option>'
        for item in a_db.get_column_list('''
            SELECT name 
            FROM personen 
            ORDER BY sortiername'''):
            select+='\t<option>'+item+'</option>'
        select+='</select>'
        a_tool.prt('''<br><b>...neu setzen:</b><form action="a_main.py" method="post" >
            '''+select+'''<br>
            <input value="Neu setzen!" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br></form>
            <br><b>...zeigen:</b><br>
            Ablesen in den <i>Stammdaten</i><br>''')
        a_tool.prt('''  <a href="a_main.py?popupaktion=schuelercodes" target="_blank" title="Öffnet sich in neuem Fenster">
                Schülercodes als csv-Datei</a><br>''')
        a_tool.prt('''  <a href="a_main.py?popupaktion=schuelerbrief" target="_blank" title="Öffnet sich in neuem Fenster">
                Serien-Mailcode-Brief</a>''')
        a_tool.prt('</div>')

    
    #Passwortänderung
    if start_admin_box(3,'User-Passwörter', extraklasse="w15",zeichen="⚷",zeichenfarbe='green',hilfetext=passwort_hilfe):
        nameselect=a_tool.get_nameselect('changepwduser')
        a_tool.prt('<br><b>...ändern:</b>')
        a_tool.prt('''<form action="a_main.py" method="post" >'''+nameselect+'''<br>
            neues Passwort: <input name="neuespasswort1" size="5" maxlength="20" type="password" ><br>
            bitte wiederholen: <input name="neuespasswort2" size="5" maxlength="20" type="password" ><br>
            <input value="Ändern" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
        a_tool.prt('<br><b>...ausgeben:</b> (nur generierte)<br>')
        a_tool.prt('''  <a href="a_main.py?popupaktion=lehrercodes" target="_blank" title="Öffnet sich in neuem Fenster">
                Passwörter als csv-Datei</a><br>''')
        a_tool.prt('''  <a href="a_main.py?popupaktion=lehrerbrief" target="_blank" title="Öffnet sich in neuem Fenster">
                Serien-Passwort-Brief</a>''')
        a_tool.prt('</div>')

    #Rechte festlegen
    if start_admin_box(4,'User-Rechte', extraklasse="w27 rechteseite",zeichen="✔",zeichenfarbe='green',hilfetext=rechte_hilfe):
        nameselect=a_tool.get_nameselect('machverwalter')
        a_tool.prt('''\n<form action="a_main.py" method="post" style="text-align:left">
            <br><b>User</b> wählen: '''+nameselect+'''<br>
            <span title="Schreibweise unbedingt wie in den eingelesenen Listen!">
                oder neuer User mit Name: <input name="verwaltername" size="12" maxlength="20"  ></span><br><br><b>Rechte</b><br>''')
        if a_db.get_config_int('minimum-js')<=4:  a_tool.prt('''Grundschulstufe:<br>
                <input type="radio" name="grechte" value="0" checked>keine
                <input type="radio" name="grechte" value="2">Stufenlehrer
                <input type="radio" name="grechte" value="4">Seki
                <input type="radio" name="grechte" value="9">Verwalter
                <br>''')
        if a_db.get_config_int('minimum-js')<=7:  a_tool.prt('''Unterstufe:<br>
                <input type="radio" name="urechte" value="0" checked>keine
                <input type="radio" name="urechte" value="2">Stufenlehrer
                <input type="radio" name="urechte" value="4">Seki
                <input type="radio" name="urechte" value="9">Verwalter
                <br>''')
        if a_db.get_config_int('minimum-js')<=10:a_tool.prt('''Mittelstufe:<br>
                <input type="radio" name="mrechte" value="0" checked>keine
                <input type="radio" name="mrechte" value="2">Stufenlehrer
                <input type="radio" name="mrechte" value="4">Seki
                <input type="radio" name="mrechte" value="9">Verwalter
                <br>''')
        a_tool.prt('''Oberstufe:<br>
                <input type="radio" name="orechte" value="0" checked>keine
                <input type="radio" name="orechte" value="2">Stufenlehrer
                <input type="radio" name="orechte" value="4">Seki
                <input type="radio" name="orechte" value="9">Verwalter
                <br>
                
            <input value="festlegen/anlegen!" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
        a_tool.prt('</div>')
    
    #Terminrechte festlegen
    if start_admin_box(5,'Termin-Rechte', extraklasse="w15 rechteseite",zeichen='#',zeichenfarbe='blue',hilfetext=terminverwalter_hilfe):
        nameselect=a_tool.get_nameselect('machterminverwalter')
        kt_liste=a_db.get_rowdict_list('SELECT klarname,trechte FROM users WHERE trechte >=7 ORDER BY klarname')
        a_tool.prt('<br>Aktuelle Sonderrechte::<br>')
        a_tool.prt(',<br>'.join( [ klarname+': '+TRECHTE_NAME[trechte] for klarname,trechte in kt_liste ] )+'<br>')
        a_tool.prt('''\n<form action="a_main.py" method="post" style="text-align:left">
            <br><b>User</b> wählen:<br>'''+nameselect+'<br>')
        a_tool.prt('''Sonderrechte bei der Terminverwaltung:<br>
            <input type="radio" name="trechte" value="0" checked>keine (also Lehrer)<br>
            <input type="radio" name="trechte" value="7">Schulleitung (darf alles lesen)<br>
            <input type="radio" name="trechte" value="9">Terminverwalter (darf alles lesen und schreiben)<br>
            <input value="festlegen/anlegen!" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
        a_tool.prt('</div>')

    # Konfiguration Vertretungslehrer
    if start_admin_box(6,'Vertretungslehrer', extraklasse="w27 rechteseite",zeichen='V',zeichenfarbe='orange',hilfetext=vertretungs_hilfe):
        vlabfrage=a_db.get_rowdict_list('''
            SELECT kbez,klehrer_nr,vlehrer_nr
            FROM kurse
            ORDER BY kbez''')
        select='<select name="kurs_fv">'  # für vertretung
        select+='\t<option>-</option>'
        for kbez, klehrer_nr, vlehrer_nr in vlabfrage:
            klehrer=a_tool.get_userklarname(klehrer_nr)
            vlehrer=' + '+a_tool.get_userklarname(vlehrer_nr) if vlehrer_nr else ''
            anzeigename=kbez+' ('+klehrer+vlehrer+')'
            select+='\t<option>'+anzeigename+'</option>'
        select+='</select>'
        
        
        select2='<select name="lehrer_fv">'  # für vertretung
        select2+='\t<option>-</option>'
        select2+='\t<option>Vertretung entfernen</option>'
        for klarname in a_db.get_column_list('''
            SELECT klarname
            FROM users
            ORDER BY klarname'''):
            select2+='\t<option>'+klarname+'</option>'
        select2+='</select>'

        a_tool.prt('''<form action="a_main.py" method="post" style="text-align:center">Der Kurs
            <br>'''+select+'<br>bekommt den Vertretungslehrer<br>'+select2)
        a_tool.prt('''<br><input value="zugewiesen!" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
        a_tool.prt('</div>')
        
    # Konfiguration Klassleiter
    if start_admin_box(7,'Klassleiter', extraklasse="w15 rechteseite",zeichen='K',zeichenfarbe='green',hilfetext=klassleiter_hilfe):
    
        rowdict_list=a_db.get_rowdict_list('''
            SELECT name, klassleiter_nr
            FROM klassen
            ORDER BY name''')
        select='<select name="klklasse">'  # für klasse
        select+='\t<option>-</option>'
        for klklasse, klassleiter_nr in rowdict_list:
            klassleiter=a_tool.get_userklarname(klassleiter_nr)
            if klassleiter: klassleiter=' ('+klassleiter+')' # führendes Space ist wichtig
            anzeigename=klklasse+klassleiter
            select+='\t<option>'+anzeigename+'</option>'
        select+='</select>'
        
        select2='<select name="klassleiter">'  # für klassleiter
        select2+='\t<option>-</option>'
        for klarname in a_db.get_column_list('''
                SELECT klarname
                FROM users
                ORDER BY klarname'''):
            select2+='\t<option>'+klarname+'</option>'
        select2+='</select>'
        
        a_tool.prt('''<form action="a_main.py" method="post" style="text-align:center">Die Klasse
            <br>'''+select+'<br>bekommt den Klassleiter<br>'+select2)
        a_tool.prt('''<br><input value="zugewiesen!" type="submit">
            <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
        a_tool.prt('</div>')

    
    ## Alias einrichten - bestehenden user als Alias mit einem Master verschmelzen lassen
    if start_admin_box(8,'Alias', extraklasse="rechteseite",zeichen='A',zeichenfarbe='green',hilfetext=alias_hilfe):
        #alle Lehrer einlesen
        userlist=a_db.get_rowdict_list('SELECT klarname,kuerzel,user_nr,rechte FROM users WHERE klarname<>"Administrator" ORDER BY sortiername')
        mselectlst=['<select name="masteruser">\n\t<option>-</option>']
        aselectlst=['<select name="aliasuser">\n\t<option>-</option>']
        for klarname,kuerzel,user_nr,rechte in userlist:
            zeile='\t<option>'+str(user_nr)+' '+klarname+a_tool.aliasliste(user_nr,klammern=True)+'</option>'
            mselectlst.append(zeile)
            aselectlst.append(zeile)
        mselectlst.append('</select>')
        mselect="".join(mselectlst)
        aselectlst.append('</select>')
        aselect="".join(aselectlst)
        
        a_tool.prt('''
                    <form action="a_main.py" method="post" style="text-align:center">
                        Dem Lehrer<br>
                        '''+mselect+'''<br>
                        zusätzlich den Alias<br>
                        '''+aselect+'''<br>
                        <input name="zuweisen" value="zuweisen!" type="submit">
                        <input name="vwsid" value="'''+str(a_s.aS.sid)+'''" type="hidden"><br>
                        Oder seinen <input name="loeschen" value="Alias löschen!" type="submit">
                    </form>''')
        a_tool.prt('</div>')

    ## ZWEITE ZEILE ##
    ##################
    
    # Einstellungen
    if start_admin_box(10,'Einstellungen', neuezeile=True, extraklasse="w27",zeichen='⚙',zeichenfarbe='red',hilfetext=einstellungen_hilfe):
        for parameter,erklaerung in configdict.items():
            if a_db.get_config(parameter,'keinWert!')=='keinWert!':
                if parameter[:5]=='flag_':
                    a_db.set_config(parameter,'0')
                else:
                    a_db.set_config(parameter,'') # hiermit wird jeder Parameter, der erklärt wird auch angelegt!
            elif parameter[:5]=='flag_':
                    if not a_db.get_config(parameter,'keineZahl').isdigit():
                        a_db.set_config(parameter,'0')
        rowdict_list=a_db.get_rowdict_list('SELECT parameter,wert FROM einstellungspaerchen WHERE NOT parameter LIKE "intern%"  ORDER BY parameter')
        for row in rowdict_list:
            parameter,wert=row
            a_tool.prt('<form action="a_main.py" method="post" >')
            a_tool.prt(parameter)
            itype='password' if parameter[-8:].lower() in ['password','passwort'] else 'text'
            a_tool.prt('<input name="ea_paerchen_wert" value="'+wert+'" type="'+itype+'" size="10" maxlength="64" /><input name="ea_paerchen_parameter" value="'+parameter+'" type="hidden">')
            a_tool.prt('<input name="easid" value="'+str(a_s.aS.sid)+'" type="hidden"><input value="Ändern" type="submit">')
            if parameter in configdict:
                a_tool.prt(a_tool.popuphilfe(configdict[parameter]))
            a_tool.prt('</form>')   
        a_tool.prt('</div>')
    
    # Gruppenrechte einstellen
    erledige_gruppenrechte_dialog()
    
    # Alle Absenzen vor gegebenem Datum fixieren oder löschen
    if start_admin_box(12,'Absenzen begrenzen', extraklasse="w27",zeichen='♻',zeichenfarbe='blue',hilfetext=ab_loesch_hilfe):
        if a_db.get_config_int('minimum-js')<=10:
            a_tool.prt('''  <form action="a_main.py" method="POST" enctype="multipart/form-data"><br>
                Fixiere Absenzen in allen Klassen vor <input name="gumdatumslimit" size="5" maxlength="12" value="'''+a_db.get_config('intern_mindestdatum-gum',a_tool.heutedatum)+'''" /><br>
                Sicher?<input name="gumbestaetigung" size="3" maxlength="5">
                <input type="submit" value="Fixieren!" />
                <input name="easid" value="'''+str(a_s.aS.sid)+'''" type="hidden"></form>''')
        a_tool.prt('''  <form action="a_main.py" method="POST" enctype="multipart/form-data"><br>
                Fixiere Q11-Absenzen vor <input name="q11datumslimit" size="5" maxlength="12" value="'''+a_db.get_config('intern_mindestdatum-q11',a_tool.heutedatum)+'''" /><br>
                Sicher?<input name="q11bestaetigung" size="3" maxlength="5">
                <input type="submit" value="Fixieren!" />
                <input name="easid" value="'''+str(a_s.aS.sid)+'''" type="hidden"></form>''')
        a_tool.prt('''  <form action="a_main.py" method="POST" enctype="multipart/form-data"><br>
                Fixiere Q12-Absenzen vor <input name="q12datumslimit" size="5" maxlength="12" value="'''+a_db.get_config('intern_mindestdatum-q12',a_tool.heutedatum)+'''" /><br>
                Sicher?<input name="q12bestaetigung" size="3" maxlength="5">
                <input type="submit" value="Fixieren!" />
                <input name="easid" value="'''+str(a_s.aS.sid)+'''" type="hidden"></form>''')
        a_tool.prt('''  <form action="a_main.py" method="POST" enctype="multipart/form-data"><br>
                <span style="color:red;font-size:120%">⚠</span>
                Alle Absenzen vor dem Stichtag <input name="delalldatumslimit" size="5" maxlength="12" 
                value="'''+a_tool.isodatum_plus_tage(a_tool.heutedatum,-365)+'''" /> aus der Datenbank löschen!<br>SicherSicher?<input name="delallbestaetigung" size="5" maxlength="10">
                <input type="submit" value="Jetzt löschen!" />
                <input name="easid" value="'''+str(a_s.aS.sid)+'''" type="hidden"></form>''')
        a_tool.prt('</div>')

    
    # Suche nach Schülern, die Attestpflicht haben
    personen_mit_ap_zahl=0
    rowdict_list=a_db.get_rowdict_list('''
        SELECT name,klasse
        FROM personen 
        WHERE   apdatum<"9999-99-99"
        ORDER BY sortiername''')
    select='<select name="personen_mit_ap">'
    select+='\t<option>-</option>'
    select+='\t<option>ALLE</option>'
    for name, klasse in rowdict_list:
        anzeigename=name+' ('+klasse+')'
        select+='\t<option>'+anzeigename+'</option>'
        personen_mit_ap_zahl+=1
    select+='</select>'
    if personen_mit_ap_zahl>0:
        if start_admin_box(13,'Attestpflicht aufhb.', extraklasse="w15",zeichen='✘',zeichenfarbe='red',hilfetext=s_loesch_ap_hilfe):
            a_tool.prt('''<form action="a_main.py" method="post" >
                <br>'''+select+'''<br>
                <input value="Attestpflicht löschen!" type="submit">
                <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
            a_tool.prt('</div>\n\n')
    
    # Suche nach Schülern, die keine Klasse und keinen Kurs besuchen (js<11)
    personenohnekurszahl=0
    select='<select name="personenohnekurs">'
    select+='\t<option>-</option>'
    select+='\t<option>ALLE</option>'
    rowdict_list=a_db.get_rowdict_list('''
        SELECT name,js
        FROM personen 
        WHERE   js<11 AND klasse=""
        ORDER BY sortiername''')
    for (name,js) in rowdict_list:
        select+='\t<option>'+name+' ('+str(js)+')</option>'
        personenohnekurszahl+=1
    
    
    for name in a_db.get_column_list('''
            SELECT name,sortiername
            FROM personen 
            WHERE   (js>10 AND
                    name NOT IN 
                    (SELECT DISTINCT name 
                     FROM personen,kurse,p2k 
                     WHERE (personen.pid=p2k.pid AND kurse.kbez=p2k.kbez) ))
                OR js=0
            ORDER BY sortiername'''):
        select+='\t<option>'+name+' (Q)</option>'
        personenohnekurszahl+=1
    
    select+='</select>'
    if personenohnekurszahl>0:
        if start_admin_box(14,'Schüler ohne K.', extraklasse="w15 rechteseite",zeichen='✘',zeichenfarbe='red',hilfetext=s_loesch_hilfe):
            a_tool.prt('''<form action="a_main.py" method="post" >
                <br>'''+select+'''<br>
                <input value="Schüler löschen!" type="submit">
                <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
            a_tool.prt('</div>\n\n')
    
    # Suche nach Usern, die keinen Kurs leiten und keine Klasse haben
    userohnekurszahl=0
    klarname_list=a_db.get_column_list('''
        SELECT klarname
        FROM users
        WHERE klarname NOT IN
                (SELECT DISTINCT klarname
                 FROM users,kurse
                 WHERE ( users.user_nr=kurse.klehrer_nr 
                      OR users.user_nr=kurse.vlehrer_nr) )
            AND klarname NOT IN
                (SELECT DISTINCT klarname
                 FROM users,lehrerinklasse
                 WHERE ( users.user_nr=lehrerinklasse.user_nr) )
            AND klarname <>"Administrator"
            AND rechte="0000"
        ORDER BY sortiername''')
    select='<select name="userohnekurs">'
    select+='\t<option>-</option>'
    select+='\t<option>ALLE</option>'
    for klarname in klarname_list:
        userohnekurszahl+=1
        select+='\t<option>'+klarname+'</option>'
    select+='</select>'
    if userohnekurszahl>0:
        if start_admin_box(15,'User ohne K.', extraklasse="w15 rechteseite",zeichen='✘',zeichenfarbe='red',hilfetext=u_loesch_hilfe):
            a_tool.prt('''<form action="a_main.py" method="post" >
                <br>'''+select+'''<br>
                <input value="User löschen!" type="submit">
                <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
            a_tool.prt('</div>\n\n')
        
    # Suche nach Kurs/Klasse ohne Schüler
    kkohnezahl=0
    select='<select name="kkohne">'
    select+='\t<option>-</option>'
    select+='\t<option>ALLE</option>'
    listekk=liste_aller_kk_ohne_schueler()
    for name in listekk:
        kkohnezahl+=1
        select+='\t<option>'+name+'</option>'
    select+='</select>'
    if kkohnezahl>0:
        if start_admin_box(16,'K. ohne Schüler', extraklasse="w15 rechteseite",zeichen='✘',zeichenfarbe='red',hilfetext=k_loesch_hilfe):
            a_tool.prt('''<form action="a_main.py" method="post" >
                <br>'''+select+'''<br>
                <input value="Klasse/Kurs löschen!" type="submit">
                <input name="easid" value="'''+str(a_s.aS.sid)+'" type="hidden"></form>')
            a_tool.prt('</div>\n\n')
    
    #Ende der Admindialoge
    a_tool.prt('</div>')
    
def liste_aller_kk_ohne_schueler():
    listekk=[]
    
    for item in a_db.get_column_list('''
        SELECT name
        FROM klassen
        WHERE name NOT IN
            (SELECT DISTINCT klassen.name
             FROM klassen,personen
             WHERE (klassen.name=personen.klasse))
        ORDER BY name'''):
        listekk.append(item)
    
    for item in a_db.get_column_list('''
        SELECT kbez
        FROM kurse
        WHERE kbez NOT IN
            (SELECT DISTINCT kbez
             FROM p2k)
        ORDER BY kbez'''):
        listekk.append(item)
    return listekk
    
    
def erledige_admin_todo():
    ea_erfolg=""
    easid=a_tool.getcgiparameter('easid')
    if easid==str(a_s.aS.sid):
        ## Absenzen fixieren/löschen !!
        q11datumslimit=a_tool.getcgiparameter('q11datumslimit')
        q12datumslimit=a_tool.getcgiparameter('q12datumslimit')
        gumdatumslimit=a_tool.getcgiparameter('gumdatumslimit')
        delalldatumslimit=a_tool.getcgiparameter('delalldatumslimit')
        q11bestaetigung=a_tool.getcgiparameter('q11bestaetigung').lower()
        q12bestaetigung=a_tool.getcgiparameter('q12bestaetigung').lower()
        gumbestaetigung=a_tool.getcgiparameter('gumbestaetigung').lower()
        delallbestaetigung=a_tool.getcgiparameter('delallbestaetigung').lower()
        anzahl=0 
        
        if delallbestaetigung=='jasicher':
            if not a_tool.istisodatum(delalldatumslimit):
                ea_erfolg+='-Datum nicht erkannt - ISO-Format wie vorgeschlagen verwenden!'
            else:
                a_db.execute('DELETE FROM absenzen WHERE datum<?',(delalldatumslimit,))
                ea_erfolg+='+Alle Absenzen vor '+delalldatum+' aus der Datenbank gelöscht!'
        elif len(delallbestaetigung)>0:
            ea_erfolg+='-Fragt jemand SicherSicher? so antwortet man jasicher'
            
        if len(q11datumslimit)>0:
            if a_tool.istisodatum(q11datumslimit) and q11bestaetigung=="ja":
                #anzahl=absenzenbereinigung(q11datumslimit,11,11)
                ea_erfolg+='+Q11-Absenzen vor '+q11datumslimit+' fixiert.'
                a_db.set_config('intern_mindestdatum-q11',q11datumslimit)
            elif not a_tool.istisodatum(q11datumslimit):
                ea_erfolg+='-Kein korrektes Datum zum Absenzenfixieren erkannt ('+q11datumslimit+')'
            else:
                ea_erfolg+='-Fragt jemand "Sicher?", dann antwortet man mit "Ja"'

        if len(q12datumslimit)>0:
            if a_tool.istisodatum(q12datumslimit) and q12bestaetigung=="ja":
                #anzahl=absenzenbereinigung(q12datumslimit,12,12)
                ea_erfolg+='+Q12-Absenzen vor '+q12datumslimit+' fixiert.'
                a_db.set_config('intern_mindestdatum-q12',q12datumslimit)
            elif not a_tool.istisodatum(q12datumslimit):
                ea_erfolg+='-Kein korrektes Datum zum Absenzenfixieren erkannt ('+q12datumslimit+')'
            else:
                ea_erfolg+='-Fragt jemand "Sicher?", dann antwortet man mit "Ja"'

        if len(gumdatumslimit)>0:
            if a_tool.istisodatum(gumdatumslimit) and gumbestaetigung=="ja":
                #anzahl=absenzenbereinigung(gumdatumslimit,1,10)
                ea_erfolg+='+GUM-Absenzen vor '+gumdatumslimit+' fixiert.'
                a_db.set_config('intern_mindestdatum-gum',gumdatumslimit)
            elif not a_tool.istisodatum(gumdatumslimit):
                ea_erfolg+='-Kein korrektes Datum zum Absenzenfixieren erkannt ('+gumdatumslimit+')'
            else:
                ea_erfolg+='-Fragt jemand "Sicher?", dann antwortet man mit "Ja"'


        ## Passwortänderung
        cpu=a_tool.getcgiparameter('changepwduser')
        neuespasswort=a_tool.getcgiparameter('neuespasswort1')
        if len(cpu)>2 and len(neuespasswort)>=4:
            rowdict_list=a_db.get_rowdict_list('SELECT klarname,kuerzel FROM users WHERE klarname=?',(cpu,))
            for row in rowdict_list:
                if neuespasswort==a_tool.getcgiparameter('neuespasswort2'):
                    ea_erfolg+=a_tool.setze_user_passwort(row["klarname"],row["kuerzel"],neuespasswort)
                else:
                    ea_erfolg+='-Passwörter stimmen nicht überein'

        ## Rechte festlegen
        mverwalter=a_tool.getcgiparameter('machverwalter')
        mverwalter_stufen=0
        ### mverwalter ist das Ergebnis einer Auswahl, alternativ konnte ein verwaltername eingetippt werden:
        if len(mverwalter)<=2:
            mverwalter=a_tool.bereinige_name(a_tool.getcgiparameter('verwaltername'))
            if len(mverwalter)>2:
                a_tool.lege_user_an(mverwalter)
                ea_erfolg+='+'+mverwalter+' angelegt. '
        if len(mverwalter)>2:
            grechte=a_tool.getcgiparameter('grechte')
            urechte=a_tool.getcgiparameter('urechte')
            mrechte=a_tool.getcgiparameter('mrechte')
            orechte=a_tool.getcgiparameter('orechte')
            
            neurechte=''
            legalewerte=["2","4","9"]
            neurechte += grechte if grechte in legalewerte else "0"
            neurechte += urechte if urechte in legalewerte else "0"
            neurechte += mrechte if mrechte in legalewerte else "0"
            neurechte += orechte if orechte in legalewerte else "0"
            
            a_tool.setze_user_gruppe(mverwalter,neurechte)
            ea_erfolg+="+Lehrerstatus von "+mverwalter+" neu gesetzt auf "+neurechte+' wegen '+grechte+urechte+mrechte+orechte
                
        ## Mailcode neu setzen
        mcperson=a_tool.getcgiparameter('mcperson')
        if len(mcperson)>2:
            codeexistiert=True
            while codeexistiert:
                zugriffscode=a_tool.zufallscode()
                codeexistiert=a_db.get_existenz('''SELECT pid FROM personen WHERE zugriffscode=?''',(zugriffscode,))
            a_db.execute('''UPDATE personen SET zugriffscode=? WHERE name=?''',(zugriffscode,mcperson))
            ea_erfolg+='+Neuer Code für '+mcperson+' lautet: '+zugriffscode+' (in den Stammdaten nachzulesen)'

        # Terminverwalter ändern
        tuser=a_tool.getcgiparameter('machterminverwalter')
        trechte=a_tool.getcgiparameter('trechte')
        if len(tuser)>1 and trechte.isdigit():
            a_tool.setze_trechte(tuser,trechte)
        
        # Vertretungslehrer eintragen
        kurs_fv=a_tool.getcgiparameter("kurs_fv").split(" ")[0] # nur vor dem ersten Space
        lehrer_fv=a_tool.getcgiparameter("lehrer_fv")
        if len(lehrer_fv)>1 and len(kurs_fv)>1:
            if lehrer_fv=="Vertretung entfernen":
                lehrer_fv=""
                lehrer_fv_nr=0
            else:
                lehrer_fv_nr=a_tool.get_user_nr(lehrer_fv) 
            a_db.execute('UPDATE kurse SET vlehrer_nr=? WHERE kbez=?',(lehrer_fv_nr,kurs_fv))
            ea_erfolg+= '+Dem Kurs '+kurs_fv+' wurde der Vertretungslehrer '+lehrer_fv+' zugewiesen. Beide können nun "vermissen"!' if lehrer_fv else \
                        '+Dem Kurs '+kurs_fv+' wurde der Vertretungslehrer entfernt.'
            
        # Klassenlehrer eintragen
        klklasse=a_tool.getcgiparameter("klklasse").split(" ")[0] # nur vor dem ersten Space
        klassleiter=a_tool.getcgiparameter("klassleiter")
        klassleiter_nr=a_tool.get_user_nr(klassleiter)
        if len(klassleiter)>1 and len(klklasse)>1:
            a_db.execute('UPDATE klassen SET klassleiter_nr=? WHERE name=?',(klassleiter_nr,klklasse))
            ea_erfolg+= '+Die Klasse '+klklasse+' hat nun den Klassleiter '+klassleiter
            
        ## Attestpflicht löschen
        pma=a_tool.getcgiparameter('personen_mit_ap')
        if len(pma)>2:
            rowdict_list=a_db.get_rowdict_list('''
                SELECT name,klasse,pid
                FROM personen 
                WHERE   apdatum<"9999-99-99"
                ORDER BY sortiername''')
            todelete=[]
            ea_erfolg+='+ <b>Attestpflicht entfernt bei:</b>'
            for name,klasse,pid in rowdict_list:
                anzeigename=name+' ('+klasse+')'
                if anzeigename==pma or pma=="ALLE":
                    todelete.append((name,pid))
            if len(todelete)>0:
                for name,pid in todelete:
                    a_db.execute('''
                        UPDATE personen
                        SET apdatum=?
                        WHERE pid=?''',('9999-99-99',pid))
                    ea_erfolg+=' ('+name+')'
        
        ## PersonenOhneKlasse/Kurs löschen
        pok=a_tool.getcgiparameter('personenohnekurs')
        if len(pok)>2:
            j=""
            if "(" in pok:
                j=pok[pok.find("(")+1:pok.find(")")]
                pok=pok[:pok.find("(")]
            pok=pok.strip()
            ea_erfolg+='+<b>Entfernt wurden die Schüler:</b> '
            todelete=[]
            if j.isdigit() or pok=="ALLE":
                rowdict_list=a_db.get_rowdict_list('''
                    SELECT name,pid,js
                    FROM personen 
                    WHERE js<11 AND klasse=""
                    ORDER BY sortiername''')
                for name, pid, js in rowdict_list:
                    if name==pok or pok=="ALLE":
                        todelete.append((name,pid," "+str(js)))
            if j=="Q" or pok=="ALLE":
                rowdict_list=a_db.get_rowdict_list('''
                    SELECT name,pid
                    FROM personen 
                    WHERE (js>10 AND
                          name NOT IN 
                            (SELECT DISTINCT name 
                            FROM personen,kurse,p2k 
                            WHERE (personen.pid=p2k.pid AND kurse.kbez=p2k.kbez) ))
                        OR js=0
                    ORDER BY sortiername''')
                for name, pid in rowdict_list:
                    if name==pok or pok=="ALLE":
                        todelete.append((name,pid,' Q'))
            if len(todelete)>0:
                for name,pid,j in todelete:
                    a_db.execute('DELETE FROM absenzen WHERE pid=?',(pid,),do_commit=False)
                    a_db.execute('DELETE FROM personen WHERE pid=?',(pid,))
                    ea_erfolg+=' ('+name+j+')'
                a_tool.bestimme_anfangsbuchstabenverteilung()
                
        ## UserOhneKurs löschen
        pok=a_tool.getcgiparameter('userohnekurs')
        if len(pok)>2:
            item_list=a_db.get_column_list('''
                SELECT klarname
                FROM users
                WHERE klarname NOT IN
                    (SELECT DISTINCT klarname
                     FROM users,kurse,lehrerinklasse
                     WHERE (users.user_nr=kurse.klehrer_nr OR users.user_nr=kurse.vlehrer_nr OR users.user_nr=lehrerinklasse.user_nr))
                    AND klarname <>"Administrator"
                    AND rechte="0000"
                ORDER BY sortiername''')
            todelete=[]
            ea_erfolg+='+ <b>Entfernt wurden die Lehrkräfte:</b>'
            for name in item_list:
                if name==pok or pok=="ALLE":
                    todelete.append(name)
            if len(todelete)>0:
                for name in todelete:
                    a_db.execute('DELETE FROM users WHERE klarname=?',(name,),do_commit=False)
                    ea_erfolg+=' ('+name+')'
                a_db.commit()
                
        ## Klassen/Kurse ohne Schüler löschen
        kko=a_tool.getcgiparameter('kkohne')
        if len(kko)>2:
            listekk=liste_aller_kk_ohne_schueler()
            todelete=[]
            ea_erfolg+='+ <b>Entfernt wurden die Klassen/Kurse:</b>'
            for name in listekk:
                if name==kko or kko=="ALLE":
                    todelete.append(name)
            if len(todelete)>0:
                for name in todelete:
                    a_db.execute('DELETE FROM kurse WHERE kbez=?',(name,),do_commit=False)
                    a_db.execute('DELETE FROM klassen WHERE name=?',(name,),do_commit=False)
                    ea_erfolg+=' ('+name+')'
                a_db.commit()
        eapp=a_tool.getcgiparameter('ea_paerchen_parameter')
        if len(eapp)>0:
            eapw=a_tool.getcgiparameter('ea_paerchen_wert')
            if len(eapw)>0:
                a_db.set_config(eapp,eapw)
            else:
                a_tool.remove_config(eapp)
        
        easr=a_tool.getcgilist('sekirechte')
        eakr=a_tool.getcgilist('klrechte')
        if easr or eakr:
            ea_erfolg+=erledige_gruppenrechte_todo(easr,eakr)
        return ea_erfolg
    showhide_sid=a_tool.getcgiinteger("showhide_sid")   
    if showhide_sid==a_s.aS.sid:
        showhide_nr=a_tool.getcgiinteger("showhide_nr")
        if showhide_nr>0:
            flag=a_db.get_config('intern_showhide_{:03}'.format(showhide_nr),'show')
            if flag!='hide':
                a_db.set_config('intern_showhide_{:03}'.format(showhide_nr),'hide')
            else:
                a_db.set_config('intern_showhide_{:03}'.format(showhide_nr),'show')
        showhide_20=a_tool.getcgiparameter("showhide_20")
        if showhide_20=='+':
            for i in range(1,20):
                a_db.set_config('intern_showhide_{:03}'.format(i),'show')
        elif showhide_20 in ['‒','-']:
            for i in range(1,20):
                a_db.set_config('intern_showhide_{:03}'.format(i),'hide')
    return ''


def soll_anzeigen(nr,name):
    flag=a_db.get_config('intern_showhide_{:03}'.format(nr),'show')=='show'
    if flag:
        name=''
    umschaltquelltext='''{name} <boxform><form class="boxcontrol" action="a_main.py" method="POST" style="font-weight:bold;">
        <input name="showhide_sid" type="hidden" value="{sid}"  />
        <input name="showhide_nr" type="hidden" value="{nr}"  />
        <input   name="showhide" 
                        type="submit" 
                        value="{anaus}" 
                        style="font-weight:bold;color:{color};" 
                        title="{title}" />
    </form></boxform>'''.format(  sid=a_s.aS.sid, nr=nr, name=name, \
                        anaus="‒" if flag else "+", 
                        color="red" if flag else "green", 
                        title="verbergen" if flag else "zeigen")
    return flag, umschaltquelltext

def start_admin_box(nr,titel,neuezeile=False, extraklasse="",zeichen='',zeichenfarbe="red",titelfarbe="",hilfetext=""):
    zeigeflag,umschalttext=soll_anzeigen(nr,titel)
    boxklasse="s1" if neuezeile else "s2"
    if zeigeflag:
        a_tool.prt('<div class="'+boxklasse+' '+extraklasse+'">')
        a_tool.prt(a_tool.popuphilfe(hilfetext,final=''))
        a_tool.prt(umschalttext)
        a_tool.prt(a_tool.headhelper(zeichen,zeichenfarbe,titel,titelfarbe))
        a_tool.prt('<br>')
        if not zeichen:
            a_tool.prt('<br>')
        return True # heißt: div ist offen, kann nun befüllt und mit </div> geschlossen werden
    a_tool.prt('<div class="'+boxklasse+'">'+a_tool.popuphilfe(hilfetext,final='')+umschalttext+'&nbsp;')
    a_tool.prt('</div>\n\n')
    return False
        
def absenzenbereinigung(datum, von_js,bis_js):
    # VERALTETE CODERESTE FIXME!
    #neuerkommentar='<br>'+a_tool.isodatum2datum(a_tool.heutedatum)+' Bereinigung (vor '+a_tool.isodatum2datum(datum)+')'
    anzahl=0
    rowdict_list=a_db.get_rowdict_list('''
       SELECT pid,datum,kommentar 
         FROM absenzen 
        WHERE datum<? 
          AND status>?
          AND pid IN                                          
            (SELECT pid FROM personen WHERE js BETWEEN ? AND ?)''',(datum,LEVEL_GELOESCHT,von_js,bis_js))
    #zuloeschenliste=[]
    for row in rowdict_list:
    #    zuloeschenliste.append(row)
    #for row in zuloeschenliste:
    #   pid,datum,kommentar=row
    #    #a_tool.prt(kommentar+'+'+neuerkommentar)
    #    db_cursor . execute('''
    #        UPDATE absenzen
    #        SET status=?, attestpflicht=0, kommentar=? 
    #        WHERE pid=? AND datum=? ''',(LEVEL_GELOESCHT,kommentar+neuerkommentar,pid,datum))
        anzahl+=1
    return anzahl

def erledige_gruppenrechte_dialog():
    #Gruppenrechte festlegen - was darf Seki, was darf Klassleiter?
    if start_admin_box(11,'Rechte Sek./Klassl.', extraklasse="w15",zeichen='+/-',zeichenfarbe='orange',hilfetext=gruppenrechte_hilfe):
        ausgabe=[]
        ausgabe.append('''\n<form action="a_main.py" method="post" style="text-align:left">
            Was darf ein Mitglied der Gruppe eingeben/auswählen? Alles bis "Entschuldigung ok" ist immer erlaubt.<br>''')
        zeilen=['']*LENRECHTE
        for titel,gruppe in [('&nbsp; ┌ Sekretariat','seki'),('&nbsp; │ '+'&nbsp;'*3+'┌ Klassleiter','kl')]:
            ausgabe.append(titel+'<br>')
            for level in range(LEVEL_ENTSCHULDIGUNG+1,LENRECHTE):
                if STATUSSTRG[level]!='?':
                    checked=' checked ' if a_tool.get_gruppenrechte(gruppe,level) else ''
                    zeilen[level]+='<input type="checkbox" name="'+gruppe+'rechte" value="'+str(level)+'"'+checked+' >'
                    if gruppe=='kl':
                        zeilen[level]+=STATUSSTRG[level]+'<br>\n'
        ausgabe.append(''.join(zeilen))
        ausgabe.append('<input value="So festlegen!" type="submit"><input name="easid" value="'+str(a_s.aS.sid)+'" type="hidden"></form>')
        ausgabe.append('</div>\n\n')    
        a_tool.prt("\n".join(ausgabe))

def erledige_gruppenrechte_todo(s,k):
    for i in range(len(s)): 
        if s[i].isdigit: s[i]=int(s[i])
    for i in range(len(k)): 
        if k[i].isdigit: k[i]=int(k[i])
    
    for gruppe,liste in [('seki',s),('kl',k)]:
        for level in range(LENRECHTE):
            if level<=LEVEL_ENTSCHULDIGUNG or level in liste:
                a_tool.set_gruppenrechte(gruppe,level,1)
            else:
                a_tool.set_gruppenrechte(gruppe,level,0)
            
    return "+Rechte neu gesetzt ("+str(s)+"+"+str(k)+")"
    
                    

configdict={ 'minimum-js':'Die kleinste vorkommende Jahrgangsstufe - wird beim GUM-Einlesen gesetzt. Kann bei fehlerhaften Daten absichtlich limitiert werden.', \
            'kurskriterium-q11':'Mit welcher Zeichenkette beginnen Kurse, die in Q11 gehören? Nichts gesetzt: 1', \
            'kurskriterium-q12':'Mit welcher Zeichenkette beginnen Kurse, die in Q12 gehören? Nichts gesetzt: 2', \
            'aa-mailadresse':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Schüler müssen an diese Adresse schreiben', \
            'aa-passwort':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Die genannte Adresse hat dieses POP- und SMTP-Passwort', \
            'aa-popserver':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Dies ist der POP-Server (muss secure unterstützen)', \
            'aa-smtpserver':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Dies ist der SMTP-Server (muss secure unterstützen)', \
            'aa-adminadresse':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Diese Absendeadresse erhalten die Bestätigungsmails (um Bouncing zu verhindern sollte sie eine andere Adresse sein)', \
            'aa-stundemorgen':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Ab dieser Stunde gilt eine Absenz für den Folgetag', \
            'aa-stundegrenze':'<i>Absenzenautomat</i> (Krankmeldungen via Email):<br>Ab dieser Stunde werden Krankmeldungen abgelehnt. Ist diese Stunde größer als aa-stundemorgen, so werden keine Mails abgelehnt', \
            'loginzeitstandard':'So viele Minuten bleibt ein untätiger Lehrer angemeldet', \
            'loginzeitbuero':'So viele Minuten bleibt ein untätiger Verwalter oder Sekretariat angemeldet, die in einem Büro arbeiten', \
            'flag_auto_absenz':'Soll die dritte Absenz in Folge zur Attestpflicht führen?', \
            'flag_monatsstatistik':'Soll im Absenzenbrief jeden Monat die Zahl der Tage mit/ohne Attest aufgeführt werden?', \
            'flag_termineanzeigen':'Soll die Terminverwaltung (inkl. Schulaufgabenplan) angezeigt werden?', \
            'AdresseInfoDisplay':'Von welcher IP-Adresse darf eine InfoDisplaySoftware Terminlisten abfragen?', \
            }

