#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_um_einlesen.py                                                            
 This file is free software under              
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_um_einlesen.py liest 
  1. die Liste (aus WinSV) aller 
    Schüler der Unter- und Mittelstufe mit ihrer Klasse ein
    - legt Klassen an
    - legt Schüler an
  2. die Liste (aus WinLD) aller
    Lehrer der Unter- und Mittelstufe ein und ordnet sie ihren
    Klassen zu
________________________________________________________________________
'''

import sys
import codecs
import time, datetime
import random

import cgi
import cgitb; cgitb.enable()
import os, sys

import hashlib
import a_main, a_tool, a_upload
import a_db

from a_konstanten import *


def schueler_import(typ=1):
    global db_conn
    global db_cursor
    importerfolg=False
    a_db.execute('UPDATE personen SET klasse="" WHERE js<11 ',do_commit=False)         # alle Klasseneinträge der UM-Schüler löschen
    if typ==0:
        f=codecs.open(a_tool.get_datenpfad()+"schuelerliste.txt",mode="r",encoding='iso-8859-1')
    elif typ==1:
        f=codecs.open(a_tool.get_datenpfad()+"schuelerliste.txt",mode="r",encoding='utf-8')
    zeilenzahl=0
    letzteklasse=""
    js=0
    for zeile in f:
        zeilenzahl+=1
        if debuglevel>0: a_tool.importlog("Z.Nr."+str(zeilenzahl)+": "+str(zeile))
        schueler=''
        if typ==0:
            zeilenarray=zeile.split('"')                            #zerlege "7a"|"Hansi Müller" in ['7a','|','Hansi Müller']
            if len(zeilenarray[0].strip())==0:                      #führende whitespaces stören nur
                zeilenarray=zeilenarray[1:]
            if debuglevel>1: a_tool.importlog(str(zeilenarray))
            if len(zeilenarray)>2 and zeilenarray[1]=="|":
                # Lese einen Schüler ein
                klasse=zeilenarray[0]
                schueler=zeilenarray[2]
        elif typ==1:
            zeilenarray=zeile.strip().split(';')                    #zerlege 13;Gabi Köster;9a in ['13','Gabi Köster','9a']
            if len(zeilenarray[0].strip())==0:                      #führende whitespaces stören nur
                zeilenarray=zeilenarray[1:]
            if debuglevel>1: a_tool.importlog(str(zeilenarray))
            if len(zeilenarray)>2 and zeilenarray[0].isdigit():
                # Lese einen Schüler ein
                klasse=zeilenarray[2].strip()
                schueler=zeilenarray[1].strip()
            elif len(zeilenarray)>=2:
                # Lese einen Schüler ein
                klasse=zeilenarray[1].strip()
                schueler=zeilenarray[0].strip()
                
        if schueler:        
            if klasse!=letzteklasse:
                letzteklasse=klasse
                js=lege_klasse_an(klasse)
            if debuglevel>0: 
                a_tool.importlog("Schüler:"+schueler+" Klasse:"+klasse+" Jahrgangsstufe:"+str(js))
            logtxt,errtxt=a_tool.schueler_eintragen(schueler,"",js,klasse,do_commit=False)      
            if logtxt or errtxt: a_tool.importlog(logtxt,err=errtxt)
            importerfolg=True
        else:
            a_tool.importlog(zeile,err='Zeile wurde nicht als Schülereintrag erkannt: "'+zeile.strip()+'"')
    f.close()
    a_db.commit()
    return importerfolg

def lege_klasse_an(klasse,klassleiter=""):
    js=10 # was nicht mit einer ziffer beginnt kommt pauschal in die 10. Klasse, also Mittelstufe
    if len(klasse)>1 and klasse[:2].isdigit():
        js=int(klasse[:2])
    elif len(klasse)>0 and klasse[0].isdigit():
        js=int(klasse[0])
    
    klassleiter_nr=a_tool.get_user_nr(klassleiter)
    rowdict=a_db.get_one_rowdict('''SELECT name,klassleiter_nr FROM klassen WHERE name=?''',(klasse,))
    if rowdict:
        db_name,db_klassleiter_nr = rowdict
        if klassleiter_nr and db_klassleiter_nr!=klassleiter_nr:
            a_db.execute('''UPDATE klassen SET js=?, klassleiter_nr=? WHERE name=?''',(js,klassleiter_nr,klasse),do_commit=False)
    else:
        a_db.execute('''INSERT INTO klassen (name,js,klassleiter_nr) VALUES (?,?,?)''',(klasse,js,klassleiter_nr),do_commit=False)
    if js>0 and js<a_db.get_config_int('minimum-js',99):
        a_db.set_config('minimum-js',js,do_commit=False)
    return js
    
def lehrer_import(typ=1):
    global db_conn
    global db_cursor
    importerfolg=False
    a_db.execute('DELETE from lehrerinklasse',do_commit=False)                 # alle Lehrer-Klassen-Beziehungen löschen
    if typ==0: # WINSV-Stil
        f=codecs.open(a_tool.get_datenpfad()+"lehrerliste.txt",mode="r",encoding='iso-8859-1')
    elif typ==1: # ASV
        f=codecs.open(a_tool.get_datenpfad()+"lehrerliste.txt",mode="r",encoding='utf-8')
    zeilenzahl=0
    letzterlehrer=""
    for zeile in f:
        zeilenzahl+=1
        if debuglevel>1: a_tool.importlog("Z.Nr."+str(zeilenzahl)+": "+str(zeile))
        if typ==0:
            zeilenarray=zeile.split('"')                            #zerlege "Gerd Gröber"|"7a"|"9c" in ['Gerd Gröber','|','7a','|','9c']
            if len(zeilenarray[0].strip())==0:                      #führende whitespaces stören nur
                zeilenarray=zeilenarray[1:]
            lehrer=zeilenarray[0]
            klassen=zeilenarray[1:]                                 # nach dem Lehrer folgen die Klassen als weitere Items
            if debuglevel>1: a_tool.importlog(str(zeilenarray))
        if typ==1:
            zeilenarray=zeile.split(';')                            #zerlege 'Gerd Gröber; 7a,9c' in ['Gerd Gröber','7a,9c']
            if len(zeilenarray)<2:
                a_tool.importlog('',err="Zeile zu kurz, ignoriere:'"+zeile+"'")
                continue
            if len(zeilenarray[0].strip())==0 or zeilenarray[0].strip().isdigit():  #führende whitespaces bzw. laufende Nummern stören nur
                zeilenarray=zeilenarray[1:]
                if len(zeilenarray)<2:
                    a_tool.importlog('',err="Zeile zu kurz, ignoriere:'"+zeile+"'")
                    continue
            
            lehrer=zeilenarray[0]
            klassen=zeilenarray[1].split(',')                       # nach Lehrer folgt ein Intem, das eine Liste enthält, die hier gesplittet wird
            if debuglevel>1: a_tool.importlog(str(zeilenarray))
        if len(zeilenarray)>=2:
            lehrer=a_tool.bereinige_name(lehrer)
            if len(lehrer)>1:
                lehrer=a_tool.entferne_titel(lehrer)
                lehrer_nr=a_tool.lege_user_an(lehrer,do_commit=False)
                letzte_klasse=""
                for klasse in klassen:
                    klasse=klasse.strip()
                    if klasse in ["|",",",";","\n",""]:
                        continue # überspringen
                    if "_" in klasse:
                        klasse=klasse.split("_")[0]
                    if klasse!=letzte_klasse:
                        letzte_klasse=klasse
                        klasse_existiert=False
                        item=a_db.get_first_element('SELECT name FROM klassen WHERE name=?  COLLATE NOCASE',(klasse,)) # ignoriert gross/kleinschrift
                        if item:
                            klasse=item # scheint unnötig, setzt aber den richtigen namen mit gross/kleinschrift
                        else:
                            a_tool.importlog("Klasse:"+klasse+' beim Lehrereinlesen neu angelegt')
                            lege_klasse_an(klasse)
                        if not a_db.get_existenz('SELECT user_nr,kname FROM lehrerinklasse WHERE user_nr=? AND kname=?  COLLATE NOCASE',(lehrer_nr,klasse)):
                            a_db.execute('INSERT INTO lehrerinklasse (user_nr,kname) VALUES (?,?)',(lehrer_nr,klasse),do_commit=False)
                        if debuglevel>1: 
                            a_tool.importlog("Lehrer:"+lehrer+" in Klasse:"+klasse)
                        importerfolg=True
            else:
                a_tool.importlog('',err="Keine Verknüpfungen für Lehrer:"+lehrer+", da der Name zu kurz ist")
    f.close()
    a_db.commit()
    return importerfolg

            
debuglevel=2

bincgi=False

if __name__ == '__main__':
    bincgi=True
    importerfolg=False
    if a_tool.getcgiparameter('uploadtype')=='schuelerliste':
        # 1. hochgeladene Datei in Empfang nehmen und speichern
        erfolg, message=a_upload.save_uploaded_file('schuelerliste','schuelerliste.txt')
        if not erfolg:
            typ=1
            erfolg, message=a_upload.save_uploaded_file('schuelerlisteasv','schuelerliste.txt')
        else:
            typ=0
        a_tool.importlog("Schuelerlisteupload",message)
        # 2. Datei in die Datenbank einlesen
        if erfolg:  
           if True: #try:
                if schueler_import(typ):
                    a_tool.importlog(a_tool.bestimme_anfangsbuchstabenverteilung())
                    a_tool.importlogfinish()
                    importerfolg=True
                    a_main.absentmain('+Einlesen der Schülerliste erfolgreich',kurspflicht='Stammdaten',fehlerliste=a_tool.get_importerrors())
            #except:
            #   pass
    elif a_tool.getcgiparameter('uploadtype')=='lehrerliste':
        # 1. hochgeladene Datei in Empfang nehmen und speichern
        erfolg, message=a_upload.save_uploaded_file('lehrerliste','lehrerliste.txt')
        if not erfolg:
            typ=1
            erfolg, message=a_upload.save_uploaded_file('lehrerlisteasv','lehrerliste.txt')
        else:
            typ=0
        a_tool.importlog("Lehrerlisteupload",message)
        # 2. Datei in die Datenbank einlesen
        if erfolg:  
            if True: #try:
                if lehrer_import():
                    a_tool.importlogfinish()
                    importerfolg=True
                    a_main.absentmain('+Einlesen der Lehrerliste erfolgreich',kurspflicht='Stammdaten',fehlerliste=a_tool.get_importerrors())
            #except:
            #   pass
        
    if not importerfolg:
        a_tool.importlogfinish()
        a_main.absentmain('-Fehler beim Einlesen ('+(['Nichts eingelesen?']+a_tool.logliste)[-1]+')')
