#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_upload.py                                                            
 This file is free software under              
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_upload.py ermöglicht, dass eine Datei hochgeladen wird.
 Gespeichert wird sie nur:
    wenn ihr Name in der Liste legaler Dateinamen enthalten ist
    wenn sie max 2 MB groß ist
________________________________________________________________________
'''

import sys
import codecs

import os, sys

import sqlite3, hashlib
import a_main, a_tool

dateibez=['kursliste','absenzenbrief','mailcodebrief','passwortbrief']
dateinamen=['kursliste.txt','absenzenbrief.html','mailcodebrief.html','passwortbrief.html']

def save_uploaded_file (dateiinput="",filename=""):
    '''dateiinput ist der Name des CGI-Parameters, der die Datei enthält'''
    uploadsid=a_tool.getcgiparameter('uploadsid')
    if not a_main.ist_legitimer_admin(uploadsid):
        return False,"Uploadfehler: Aufruf nicht durch einen legitimierten Admin!"
    
    success=False
    meldung=""
    
    # Wurde eine Datei explizit vorgegeben?
    if len(dateiinput)>0:
        if len(a_tool.getcgiparameter(dateiinput,''))<2 : 
            return False,"Uploadfehler: es wurde nicht die gewünschte Datei übergeben"
    else:
        #wenn nicht, so teste alle zulässigen Dateibezeichnungen durch
        for i in range(len(dateibez)):
            if len(a_tool.getcgiparameter(dateibez[i],''))>2 : 
                dateiinput=dateibez[i]
                filename=dateinamen[i]
    if len(dateiinput)==0:
        return False,"Uploadfehler: es wurden keine Datei übergeben"
            
    fileitem = a_tool.getcgiobject(dateiinput)
    if not fileitem.file: return False,"Uploadfehler: Es wurde keine Datei übertragen"
    
    fout = open(a_tool.get_datenpfad()+filename, 'wb')          
    chunk = fileitem.file.read(2000000)                 # limitiert auf 2MB
    if chunk:
        fout.write (chunk)
        success=True
        meldung="Upload erfolgreich geschrieben"
    else:
        meldung="Uploadfehler: keine Daten angekommen"
    fout.close()
    return success,meldung

debuglevel=2

if __name__ == '__main__':
    importerfolg=False
    erfolg,meldung=save_uploaded_file()
    if erfolg:
        a_main.absentmain('+Hochladen erfolgreich')
        
    if not importerfolg:
        a_main.absentmain('-Fehler beim Hochladen: '+meldung)
