#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 ab_rufe.py                                                         
 This file is free software under          
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
         der GPL ohne jegliche Garantie ist - siehe die Datei COPYING 
________________________________________________________________________

 ab_rufe.py liefert die beiden Listen der zu rufenden Schüler,
     deren fehlende Entschuldigungen in einem gewissen Intervall liegen
________________________________________________________________________
'''

from a_konstanten import *

import a_tool
import a_db

import time, datetime
import base64
        
def rufe():
        
    # In welchem Zeitraum wird eine fehlende Entschuldigung als überfällig gemeldet
    #ts=time.localtime(time.mktime((timestamp.tm_year,timestamp.tm_mon,timestamp.tm_mday-FRIST_VON_UEBERFAELLIG,0,0,0,0,0,0)))
    #mon='0'+str(ts.tm_mon)
    #mon=mon[-2:]
    #tag='0'+str(ts.tm_mday)
    #tag=tag[-2:]
    #stichtag_von=str(ts.tm_year)+"-"+mon+"-"+tag
    #
    #ts=time.localtime(time.mktime((timestamp.tm_year,timestamp.tm_mon,timestamp.tm_mday-FRIST_BIS_UEBERFAELLIG,0,0,0,0,0,0)))
    #mon='0'+str(ts.tm_mon)
    #mon=mon[-2:]
    #tag='0'+str(ts.tm_mday)
    #tag=tag[-2:]
    #stichtag_bis=str(ts.tm_year)+"-"+mon+"-"+tag
    
    stichtag_von= a_tool.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG)
    stichtag_bis= a_tool.heute_plus_delta_datum(-FRIST_BIS_UEBERFAELLIG)
    stichtag_warn1=a_tool.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG+7) # warnt eine Woche vorher rot, flashend
    stichtag_warn2=a_tool.heute_plus_delta_datum(-FRIST_VON_UEBERFAELLIG+14) # warnt zwei Wochen vorher orange
        
    ## Nach überfälligen, aber noch lieferbaren Entschuldigungen

    namenliste={11:"",12:""}
    for js in [11,12]:
        findeflagge=False
        for pid,name,apdatum,mindate in a_db.get_rowdict_list('''
                 SELECT personen.pid,name,apdatum,min(datum)
                 FROM   personen,absenzen 
                 WHERE  personen.pid=absenzen.pid AND status>=? AND status<? 
                    AND attestpflicht=0 AND (apdatum<"2012-00-00" OR apdatum>absenzen.datum )
                    AND js = ? 
                    AND datum BETWEEN ? AND ?
                 GROUP BY name 
                 ORDER BY name''',(LEVEL_VERMISST,LEVEL_ENTSCHULDIGUNG,js,stichtag_von,stichtag_bis)):
            if findeflagge:
                namenliste[js]+=', '
            else:
                findeflagge=True
            if mindate<=stichtag_warn1:
                pre,small,post='<span class="s_t_fresh">','<small class="s_t_fresh">&nbsp;','</span>'
            elif mindate<=stichtag_warn2:
                pre,small,post='<span style="color:brown">','<small style="color:brown">&nbsp;','</span>'
            else:
                pre,small,post='','<small>&nbsp;',''
            namegeteilt=name.split(' ')
            namenliste[js]+=pre+namegeteilt[0]+small+'&nbsp;'.join(namegeteilt[1:])+'</small>'+post
        
    skelett='''<div class="content"><table cellspacing="5"><tr>
    <td nobord="true"><h4>Fehlende Entschuldigungen bzw. Atteste klären!</h4>
    <p>{namenliste}<small><small> (absenzenverwaltung)</small></small></p>
    </td></tr></table>\n</div>'''
    q11=skelett.format(namenliste=namenliste[11]) if len(namenliste[11])>0 else ""
    q12=skelett.format(namenliste=namenliste[12]) if len(namenliste[12])>0 else ""
    return q11,q12

def u_b_a(codeme):
    #utf_2_b64_2_ascii
    return base64.encodestring(codeme.encode("utf-8")).decode('ascii')
    
#######################################################
#######################################################
# Alles startet hier...

if __name__ == '__main__':
    print('''Content-Type: text/html\n\n<!DOCTYPE html><html>
    <body><h1>Datenuebertragung</h1>\n''')
    erste,zweite=rufe()
    
    b64=base64.encodestring(('Q11Q12Start '+erste+' Q11Q12Trenner '+zweite+' Q11Q12Ende').encode('utf-8'))
    dfue='Q11Q12Start {} Q11Q12Trenner {} Q11Q12Ende'.format(u_b_a(erste), u_b_a(zweite))
    print(dfue)
    print('\n</body></html>')
